unit startlib_u;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls, Dynlibs;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

const
{$IFDEF WINDOWS}
  knihovna = 'libraryvzor.dll';
{$ELSE}
  knihovna = 'liblibraryvzor.so';
{$ENDIF}

var
  MyHandle: TLibHandle;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF WINDOWS}
    MyHandle := SafeLoadLibrary(knihovna);
  {$ELSE}
    MyHandle := SafeLoadLibrary('./'+knihovna);
  {$ENDIF}
  if MyHandle=0 then begin
    MessageDlg('"'+ExtractFileName(paramstr(0))+'"! ', 'Nepodařilo se načíst knihovnu "'+knihovna+'"! Program ukončit?', mtError,[mbOK],0);
    application.Terminate;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  FreeLibrary(MyHandle);
end;

procedure TForm1.Button1Click(Sender: TObject);
type
  tctverec = function (a:integer): integer; stdcall;      // čtverec
var
  ctverec: tctverec;
begin
  ctverec := tctverec(GetProcedureAddress(MyHandle,'obsahctverce'));
  if Assigned(ctverec) then begin
    memo1.Text:='Obsah čtverce: ' + inttostr(ctverec(3));
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
type
  tobdelnik = function (a,b:integer): integer; stdcall;   // obdélník
var
  obdelnik: tobdelnik;
begin
  obdelnik := tobdelnik(GetProcedureAddress(MyHandle,'obsahobdelnika'));
  if Assigned(obdelnik) then begin
    memo1.Text:='Obsah obdélníka: ' + inttostr(obdelnik(5,7));
  end;
end;

end.

